## dtk6declarative 6.0.18

=== debian/changelog ===
dtk6declarative (6.0.18) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 08 Jul 2024 02:36:19 +0000

dtk6declarative (6.0.17) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 24 Jun 2024 05:35:03 +0000

dtk6declarative (6.0.16) unstable; urgency=medium

  * 6.0.16

 -- Mike Chen <chenke@deepin.org>  Mon, 13 May 2024 13:25:50 +0800

dtk6declarative (6.0.15) unstable; urgency=medium

  * 6.0.15

 -- YeShanShan <yeshanshan@deepin.org>  Mon, 29 Apr 2024 16:16:29 +0800

dtk6declarative (6.0.14) unstable; urgency=medium

  * 6.0.14

 -- YeShanShan <yeshanshan@deepin.org>  Sun, 28 Apr 2024 13:26:27 +0800

dtk6declarative (6.0.13) unstable; urgency=medium

  * 6.0.13

 -- YeShanShan <yeshanshan@deepin.org>  Fri, 26 Apr 2024 15:16:15 +0800

dtk6declarative (6.0.12) unstable; urgency=medium

  * 6.0.12

 -- YeShanShan <yeshanshan@deepin.org>  Tue, 23 Apr 2024 11:35:51 +0800

dtk6declarative (6.0.11) unstable; urgency=medium

  * 6.0.11

 -- Mike Chen <chenke@deepin.org>  Wed, 17 Apr 2024 17:26:16 +0800

dtk6declarative (6.0.10) unstable; urgency=medium

  * 6.0.10

 -- YeShanShan <yeshanshan@deepin.org>  Thu, 11 Apr 2024 13:36:36 +0800

dtk6declarative (6.0.9) unstable; urgency=medium

 * 6.0.9 

 -- YeShanShan <yeshanshan@deepin.org>  Fri, 29 Mar 2024 17:52:58 +0800

dtk6declarative (6.0.8) unstable; urgency=medium

  * 6.0.8

 -- Wang Fei <wangfei@deepin.org>  Tue, 05 Mar 2024 16:07:22 +0800

dtk6declarative (6.0.7) unstable; urgency=medium

  * Release 6.0.7

 -- YeShanShan <yeshanshan@deepin.org>  Wed, 31 Jan 2024 18:48:58 +0800

dtk6declarative (6.0.6) unstable; urgency=medium

  * Release 6.0.6

 -- YeShanShan <yeshanshan@deepin.org>  Tue, 30 Jan 2024 22:02:50 +0800

dtk6declarative (6.0.5) unstable; urgency=medium

  * Release 6.0.5

 -- Wang Yixue <wangyixue@deepin.org>  Thu, 18 Jan 2024 13:15:24 +0800

dtk6declarative (6.0.4) unstable; urgency=medium

  * 6.0.4

 -- wangfei <wangfei@deepin.org>  Wed, 10 Jan 2024 14:59:40 +0800

dtk6declarative (6.0.3) unstable; urgency=medium

  * 6.0.3

 -- Mike Chen <chenke@deepin.org>  Tue, 02 Jan 2024 16:19:34 +0800

dtk6declarative (6.0.2) unstable; urgency=medium

  * release 6.0.2

 -- YeShanShan <yeshanshan@deepin.org>  Wed, 29 Nov 2023 15:43:17 +0800

dtk6declarative (6.0.1) unstable; urgency=medium

  * fix: should be libdtk6core instead of libdtkcore6
  * feat: support build archlinux package for qt6
  * fix: missing qml package for dpkg

 -- YeShanShan <yeshanshan@deepin.org>  Fri, 27 Oct 2023 17:10:16 +0800

dtk6declarative (6.0.0) unstable; urgency=medium

  * fix: NavigationTitle is partially obscured(Issue: #44)
  * fix: PlaceholderText out of range(Issue: #42)
  * chore: Update README
  * chore: remove unnecessary workflows
  * feat: Support dpkg-buildpackage for qt6

 -- YeShanShan <yeshanshan@deepin.org>  Tue, 10 Oct 2023 11:02:20 +0800

dtkdeclarative (5.6.17) unstable; urgency=medium

  * Release 5.6.17

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 08 Sep 2023 15:17:44 +0800

dtkdeclarative (5.6.16) unstable; urgency=medium

  * feat: Adapt to qt6.4.2
  * feat: Support install lib and plugins for qt6
  * feat: Support install for example and template in qt6
  * fix: dpkg-buildpackage faild in qt6
  * fix: PKGBUILD qml_install_dir needs to be override

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 22 Aug 2023 06:13:45 +0000

dtkdeclarative (5.6.15) unstable; urgency=medium

  * feat: add UT for ButtonBox
  * feat: add UT for ArrowBoxPath
  * chore: add unit test ut_dquickglow
  * feat: Add UT for DSoftwareRoundedImageNode
  * feat: Add UT for DBlitFramebufferNode
  * chore: add unit test ut-iconlabel
  * feat: Add toImage function for DBlitFramebufferNode
  * chore: Can't support alpha for simpleTexture in UT
  * chore: add unit test ut-iconimage
  * chore: add unit test ut-dciiconimage
  * feat: Add UT for MaskEffectNode
  * chore: add unit test ut_dquickdciicon
  * fix: Compiling error for missing dependency
  * feat: Add UT for DSGBlurNode
  * fix: crash in ut_dquickdciiconimage
  * feat: Add UT for AppLoader-plugin
  * fix: PDS is not defined
  * chore: Remove some file for recoverage
  * chore: add unit test ut-contextMenuWindow
  * feat: Add UT for BehindWindowBlur
  * feat: Add UT for DQuickInWindowBlur
  * chore: Add unit test ut-dquickcoloroverlay
  * feat: Add UT for DQuickItemViewport
  * fix: UT failed sometimes
  * fix: UT failed in qt6
  * chore: Add unit test ut_dquickopacitymask
  * fix: UT failed in qt6 and Software renderer backend
  * fix:  DQuickItemViewport is error in software renderer
  * chore: Complementary unit test ut-globalobject
  * fix: UT failed in qt6
  * chore(UT): Wait for blur window exposed
  * fix: UT failed when unreset palette
  * feat: Add UT for DQuickBlitFrameBuffer
  * fix: PageIndicator is invalid
  * feat: Add UT to determine whether QML can load successfully
  * fix: UT failde sometimes
  * chore: Complementary unit test ut-dconfigwrapper
  * feat: Adapt to switch qt6 and qtf for qml-app-template

 -- Yixue Wang <wangyixue@deepin.org>  Fri, 11 Aug 2023 14:06:39 +0800

dtkdeclarative (5.6.14) unstable; urgency=medium

  * fix: typo
    Thanks to student-ice
  * feat: Support switching qt5 and qt6 for cmake(Issue: #87)
  * fix: Unsupported type for property assignment(Issue: #87)
  * fix: Crashed while debugging in Qt
  * feat: Support compiling between Qt5 and Qt6(Issue: #87)
  * feat: Support QQuickPalette in Qt6(Issue: #87)
  * feat: Forward ContentMenuEvent in Qt6(Issue: #87)
  * fix: Qt.color is invalid in qt5(Issue: #87)


## dtk6declarative 6.0.25

=== debian/changelog ===
dtk6declarative (6.0.25) unstable; urgency=medium

  * 6.0.25

 -- Wang Fei <wangfei@deepin.org>  Fri, 13 Dec 2024 13:30:54 +0800

dtk6declarative (6.0.24) unstable; urgency=medium

  * 6.0.24

 -- Wang Fei <wangfei@deepin.org>  Wed, 04 Dec 2024 10:26:55 +0800

dtk6declarative (6.0.23) unstable; urgency=medium

  * 6.0.23

 -- Wang Fei <wangfei@deepin.org>  Wed, 20 Nov 2024 16:44:59 +0800

dtk6declarative (6.0.22) unstable; urgency=medium

  * 6.0.22

 -- Wang Fei <wangfei@deepin.org>  Wed, 13 Nov 2024 16:14:49 +0800

dtk6declarative (6.0.21) unstable; urgency=medium

  * 6.0.21

 -- Wang Fei <wangfei@deepin.org>  Wed, 25 Sep 2024 15:09:26 +0800

dtk6declarative (6.0.20) unstable; urgency=medium

  * release 6.0.20

 -- Mike Chen <chenke@deepin.org>  Mon, 23 Sep 2024 11:13:07 +0800

dtk6declarative (6.0.19) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 21 Aug 2024 02:41:05 +0000

## dtk6declarative 6.0.34

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(DTK_VERSION "5.6.23" CACHE STRING "Define project version")
project(DtkDeclarative
    VERSION "${DTK_VERSION}"
    DESCRIPTION "DTK Declarative module"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dtkdeclarative"
    LANGUAGES CXX
)

if (${PROJECT_VERSION_MAJOR} STREQUAL "5")
    set(QT_DEFAULT_MAJOR_VERSION "5")
    set(QT_VERSION_MAJOR "5")
    set(EnableQt5 on)
    set(EnableDtk5 on)
    set(EnableQt6 off)
    set(EnableDtk6 off)
elseif(${PROJECT_VERSION_MAJOR} STREQUAL "6")
    set(QT_DEFAULT_MAJOR_VERSION "6")
    set(QT_VERSION_MAJOR "6")
    set(DTK_VERSION_MAJOR "6")
    set(EnableQt5 off)
    set(EnableDtk5 off)
    set(EnableQt6 on)
    set(EnableDtk6 on)
else()
    message(FATAL_ERROR "Only support DTK_VERSION is 5 or 6")
endif()

set(ENABLE_COV OFF CACHE BOOL "Generate coverage info")
set(LIB_NAME dtk${DTK_VERSION_MAJOR}declarative)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

include(DtkBuildConfig)
set(BUILD_DOCS ON CACHE BOOL "Generate doxygen-based documentation")

set(LIB_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}" CACHE STRING "Library install path")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/dtk${PROJECT_VERSION_MAJOR}/DDeclarative" CACHE STRING "Headers install path")
set(TEMPLATE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/qtcreator/templates/wizards/projects/qml${DTK_VERSION_MAJOR}-app-template" CACHE STRING "Directory to install QtCreator template")
set(CONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/Dtk${DTK_VERSION_MAJOR}Declarative" CACHE STRING "CMake config file install directory")
set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig" CACHE STRING "Directory to install pkg-config file")
set(MKSPECS_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/mkspecs/modules" CACHE STRING "Qt pri module install directory")
set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")

set(USE_QQuickStylePluginPrivate OFF)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR}QuickControls2)
if(EnableQt5)
if(TARGET Qt::QuickControls2 AND TARGET Qt::QuickControls2Private)
    set(USE_QQuickStylePluginPrivate ON)
endif()
endif()
if(EnableQt6)
if(TARGET Qt6::QuickControls2 AND TARGET Qt6::QuickControls2Private)
    set(USE_QQuickStylePluginPrivate ON)
endif()
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # 加上 ASAN 检查后可能会导致 DEBUG 应用启动后退出。可以加上 ASAN_OPTIONS 环境变量来防止应用退出
    # ASAN_OPTIONS="halt_on_error=0" ASAN_OPTIONS="new_delete_type_mismatch=0"
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -fno-omit-frame-pointer")
    set(BUILD_TESTING ON)
else ()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

set(DDECLARATIVE_TRANSLATIONS_DIR "dtk${PROJECT_VERSION_MAJOR}/DDeclarative/translations" CACHE STRING "DDeclarative translations directory")
set(DDECLARATIVE_TRANSLATIONS_PATH "share/${DDECLARATIVE_TRANSLATIONS_DIR}")
set(TRANSLATIONS_INSTALL_PATH "${DDECLARATIVE_TRANSLATIONS_PATH}")

set(URI "org.deepin.dtk")
string(REPLACE "." "/" URI_PATH ${URI})
set(PLUGIN_NAME dtkdeclarativeplugin)
set(STYLE_PLUGIN_NAME qtquickcontrolschameleonstyleplugin)
set(PLUGIN_OUTPUT_DIR ${PROJECT_BINARY_DIR}/plugins)

if(EnableQt5)
    add_subdirectory(src)
    add_subdirectory(qmlplugin)
endif()
if(EnableQt6)
    add_subdirectory(qt6)
endif()
add_subdirectory(chameleon)
add_subdirectory(examples)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
    add_dependencies(unit-test ${PLUGIN_NAME} ${STYLE_PLUGIN_NAME})
    if(EnableQt6)
        add_dependencies(unit-test dtkdeclarativeprivatesplugin dtkdeclarativesettingsplugin)
    endif()
endif()

# Install wizards template
set(QML_TEMPLATE_QTVERSION_INDEX 0)
if(EnableQt5)
    set(QML_TEMPLATE_QTVERSION_INDEX 3)
endif()
configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/qml-app-template/wizard.json.in"
    "${CMAKE_CURRENT_BINARY_DIR}/wizard.json"
    INSTALL_DESTINATION "${TEMPLATE_INSTALL_DIR}"
)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/wizard.json" DESTINATION "${TEMPLATE_INSTALL_DIR}")
install(DIRECTORY "${CMAKE_CURRENT_LIST_DIR}/misc/qml-app-template/" DESTINATION "${TEMPLATE_INSTALL_DIR}" FILES_MATCHING PATTERN "*" PATTERN "*.in" EXCLUDE)

configure_package_config_file(
    "${CMAKE_CURRENT_LIST_DIR}/misc/DtkDeclarativeConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfig.cmake"
    INSTALL_DESTINATION "${CONFIG_INSTALL_DIR}"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfigVersion.cmake"
    VERSION ${VERSION}
    COMPATIBILITY SameMajorVersion
)
# Install cmake config file
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfig.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Dtk${DTK_VERSION_MAJOR}DeclarativeConfigVersion.cmake" DESTINATION "${CONFIG_INSTALL_DIR}")
# Install pkg-config file
configure_file("${PROJECT_SOURCE_DIR}/misc/dtkdeclarative.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/dtk${DTK_VERSION_MAJOR}declarative.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/dtk${DTK_VERSION_MAJOR}declarative.pc" DESTINATION "${PKGCONFIG_INSTALL_DIR}")
# Install qmake module config file
configure_file("${CMAKE_CURRENT_LIST_DIR}/misc/qt_lib_dtkdeclarative.pri.in" "${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdeclarative.pri" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/qt_lib_dtkdeclarative.pri" DESTINATION "${MKSPECS_INSTALL_DIR}")

=== qt6/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

add_subdirectory(src)
add_subdirectory(src/qml/private)
add_subdirectory(src/qml/settings)

=== examples/exhibition/CMakeLists.txt ===
set(BIN_NAME dtk-exhibition)

find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Quick QuickControls2)
find_package(Dtk${DTK_VERSION_MAJOR}Core REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR}Gui REQUIRED)

set(CMAKE_EXE_LINKER_FLAGS  "-z relro -z now -z noexecstack -pie -Wl,--as-needed")

if (EnableQt5)
    set(QML_RCS ${CMAKE_CURRENT_LIST_DIR}/qml.qrc)
endif()
if (EnableQt6)
    set(QML_RCS ${CMAKE_CURRENT_LIST_DIR}/qml-qt6.qrc)
endif()
add_executable(${BIN_NAME}
    ${CMAKE_CURRENT_LIST_DIR}/main.cpp 
    ${CMAKE_CURRENT_LIST_DIR}/assets.qrc
    ${QML_RCS}
)

target_compile_options(${BIN_NAME} PRIVATE "-fpic")

target_link_libraries(${BIN_NAME} PRIVATE
    Qt${QT_VERSION_MAJOR}::Quick 
    Qt${QT_VERSION_MAJOR}::QuickControls2
    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Gui
)

set(EXAMPLE_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}")
if (EnableQt6)
    set(EXAMPLE_INSTALL_DIR "${LIB_INSTALL_DIR}/dtk${PROJECT_VERSION_MAJOR}/DDeclarative")
endif()

install(TARGETS ${BIN_NAME} DESTINATION ${EXAMPLE_INSTALL_DIR})

=== tests/apploaderplugindump/CMakeLists.txt ===
add_subdirectory(preloadplugin)
add_subdirectory(maincomponentplugin)

=== qt6/src/qml/private/CMakeLists.txt ===
#####################################################################
## dtkdeclarativeprivatesplugin Plugin:
#####################################################################

qt_add_qml_module(dtkdeclarativeprivatesplugin
    PLUGIN_TARGET dtkdeclarativeprivatesplugin
    URI "${URI}.private"
    VERSION "1.0"
    QML_FILES
        "ProgressBarImpl.qml"
        "ProgressBarPanel.qml"
        "ColorOverlay.qml"
        "SoftwareColorOverlay.qml"
        "ArrowListViewButton.qml"
        "ButtonPanel.qml"
        "KeySequenceLabel.qml"
    OUTPUT_DIRECTORY
        "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/private"
)

dtk_extend_target(dtkdeclarativeprivatesplugin EnableCov ${ENABLE_COV})

target_link_libraries(dtkdeclarativeprivatesplugin
PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Quick
)

install(TARGETS dtkdeclarativeprivatesplugin DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/private")
install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/private/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/private")

=== debian/changelog ===
dtk6declarative (6.0.34) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 17 Apr 2025 21:54:31 +0800

dtk6declarative (6.0.33) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 20 Mar 2025 17:20:51 +0800

dtk6declarative (6.0.32) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 06 Mar 2025 17:38:56 +0800

dtk6declarative (6.0.31) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 27 Feb 2025 20:57:44 +0800

dtk6declarative (6.0.30) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 13 Feb 2025 17:15:13 +0800

dtk6declarative (6.0.29) unstable; urgency=medium

  * 6.0.29

 -- YeShanShan <yeshanshan@deepin.org>  Thu, 23 Jan 2025 17:08:05 +0800

dtk6declarative (6.0.28) unstable; urgency=medium

  * 6.0.28

 -- YeShanShan <yeshanshan@deepin.org>  Tue, 14 Jan 2025 19:18:31 +0800

dtk6declarative (6.0.27) unstable; urgency=medium

  * 6.0.27

 -- YeShanShan <yeshanshan@deepin.org>  Thu, 09 Jan 2025 19:17:18 +0800

dtk6declarative (6.0.26) unstable; urgency=medium

  * 6.0.26

 -- YeShanShan <yeshanshan@deepin.org>  Thu, 02 Jan 2025 15:13:50 +0800

=== debian/control ===
Source: dtk6declarative
Section: libs
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 debhelper-compat ( =12),
 cmake,
 libdtk6gui-dev,
 libdtk6core-dev,
 libdtkcommon-dev,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-declarative-dev,
 qt6-declarative-private-dev,
 qt6-base-dev-tools,
 qt6-tools-dev,
 qt6-shadertools-dev,
 pkg-kde-tools,
 libgtest-dev,
 doxygen,
 doxyqml,
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: qml6-module-qtquick-controls2-styles-chameleon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 qml6-module-qtquick,
 qml6-module-qtquick-controls,
 qml6-module-qtquick-shapes,
 qml6-module-qt5compat-graphicaleffects,
 qml6-module-qtqml-workerscript,
 qml6-module-qtquick-templates,
 qml6-module-qtquick-effects,
 libdtk6declarative( =${binary:Version})
Description: Deepin Tool Kit Qt Quick Controls 2 QML module
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.

Package: libdtk6declarative
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  libdtk6core
Multi-Arch: same
Description: Deepin Tool Kit Gui library
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.
 .
 This package contains the shared libraries.

Package: libdtk6declarative-dev
Architecture: any
Depends: ${misc:Depends},
 libdtk6declarative( =${binary:Version}) ,
 qml6-module-qtquick-controls2-styles-chameleon( =${binary:Version}),
 libdtk6gui-dev,
 libdtk6core-dev,
 libdtkcommon-dev,
 qt6-base-dev,
 qt6-declarative-dev
Description: Deepin Tool Kit Gui Devel library
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.
 .
 This package contains the header files and shared libraries of DtkDeclarative

Package: libdtk6declarative-doc
Architecture: any
Depends: ${misc:Depends}
Description: Deepin Tool Kit Gui Devel library (Document)
 Dtkdeclarative is base library of Deepin Qt/QtQuick applications.

Package: dtk6-exhibition
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 libdtk6declarative( =${binary:Version}),
 qml6-module-qtquick-controls2-styles-chameleon( =${binary:Version})
Description: Deepin Tool Kit QML Controls example.
 This package contains a applicatioin.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
export DEB_CXXFLAGS_MAINT_APPEND = -Ofast

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')
# Fix: invalid digit "8" in octal constant. e.g.  u008 ==> 008 ==> 8
BUILD_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$2}' | sed 's/[^0-9]//g' | awk '{print int($$1)}')

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DBUILD_VERSION=$(BUILD_VER) -DDTK_VERSION=$(PACK_VER)

## dtk6declarative 6.0.36.4

=== debian/changelog ===
dtk6declarative (6.0.36.4) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Mon, 19 May 2025 17:24:07 +0800

dtk6declarative (6.0.35) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 08 May 2025 18:50:44 +0800

## dtk6declarative 6.0.38

=== debian/changelog ===
dtk6declarative (6.0.38) unstable; urgency=medium

  * Release 6.0.38

 --  yeshanshan <yeshanshan@uniontech.com>  Fri, 27 Jun 2025 17:12:32 +0800

dtk6declarative (6.0.37) unstable; urgency=medium

  * Release 6.0.37

 -- yeshanshan <yeshanshan@uniontech.com>  Thu, 19 Jun 2025 10:10:35 +0800

dtk6declarative (6.0.36) unstable; urgency=medium

  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative
  * sync: from linuxdeepin/dtkdeclarative

 -- YeShanShan <yeshanshan@uniontech.com>  Mon, 19 May 2025 17:24:07 +0800

## dtk6declarative 6.0.39

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
 cmake_minimum_required(VERSION 3.10)
 
-set(DTK_VERSION "5.6.23" CACHE STRING "Define project version")
+file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" DTK_FILE_VERSION)
+string(STRIP "${DTK_FILE_VERSION}" DTK_FILE_VERSION)
+set(DTK_VERSION "${DTK_FILE_VERSION}" CACHE STRING "Define project version")
 project(DtkDeclarative
     VERSION "${DTK_VERSION}"
     DESCRIPTION "DTK Declarative module"
@@ -69,8 +71,7 @@
 endif()
 endif()
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra")
-set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wextra")
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
     # 加上 ASAN 检查后可能会导致 DEBUG 应用启动后退出。可以加上 ASAN_OPTIONS 环境变量来防止应用退出
     # ASAN_OPTIONS="halt_on_error=0" ASAN_OPTIONS="new_delete_type_mismatch=0"

=== qt6/src/qml/settings/CMakeLists.txt ===
#####################################################################
## dtkdeclarativesettingsplugin Plugin:
#####################################################################

qt_add_qml_module(dtkdeclarativesettingsplugin
    PLUGIN_TARGET dtkdeclarativesettingsplugin
    URI "${URI}.settings"
    VERSION "1.0"
    SOURCES
        ${PROJECT_SOURCE_DIR}/src/private/dsettingscontainer_p.h
        ${PROJECT_SOURCE_DIR}/src/private/dsettingscontainer.cpp
    QML_FILES
        "SettingsDialog.qml"
        "OptionDelegate.qml"
        "CheckBox.qml"
        "LineEdit.qml"
        "ComboBox.qml"
        "NavigationTitle.qml"
        "ContentTitle.qml"
        "ContentBackground.qml"
    OUTPUT_DIRECTORY
        "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/settings"
)

dtk_extend_target(dtkdeclarativesettingsplugin EnableCov ${ENABLE_COV})

target_link_libraries(dtkdeclarativesettingsplugin
PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::CorePrivate
    Qt${QT_VERSION_MAJOR}::QuickPrivate
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::QmlPrivate
    ${LIB_NAME}
)

# 禁用此插件的 RPATH/RUNPATH，因为依赖库在标准系统路径中
set_target_properties(dtkdeclarativesettingsplugin PROPERTIES
    INSTALL_RPATH ""
    BUILD_WITH_INSTALL_RPATH TRUE
)

install(TARGETS dtkdeclarativesettingsplugin DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/settings")
install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/settings/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/settings")

=== debian/changelog ===
dtk6declarative (6.0.39) unstable; urgency=medium

  * Release 6.0.39

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 03 Jul 2025 21:13:17 +0800

## dtk6declarative 6.0.41

=== debian/changelog ===
dtk6declarative (6.0.41) unstable; urgency=medium

  * Release 6.0.41

 --  yeshanshan <packages@deepin.org>  Thu, 14 Aug 2025 19:47:44 +0800

dtk6declarative (6.0.40) unstable; urgency=medium

  * Release 6.0.40

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 31 Jul 2025 20:00:15 +0800

## dtk6declarative 6.0.44.3

=== qt6/src/qml/private/CMakeLists.txt ===
--- 
+++ 
@@ -26,5 +26,11 @@
     Qt${QT_VERSION_MAJOR}::Quick
 )
 
+# 禁用此插件的 RPATH/RUNPATH，因为依赖库在标准系统路径中
+set_target_properties(dtkdeclarativeprivatesplugin PROPERTIES
+    INSTALL_RPATH ""
+    BUILD_WITH_INSTALL_RPATH TRUE
+)
+
 install(TARGETS dtkdeclarativeprivatesplugin DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/private")
 install(DIRECTORY "${PLUGIN_OUTPUT_DIR}/${URI_PATH}/private/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/private")

=== debian/changelog ===
dtk6declarative (6.0.44.3) unstable; urgency=medium

  * Release 6.0.44

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 16 Oct 2025 19:45:30 +0800

dtk6declarative (6.0.43) unstable; urgency=medium

  * Release 6.0.43

 --  yeshanshan <packages@deepin.org>  Thu, 25 Sep 2025 16:51:47 +0800

dtk6declarative (6.0.42) unstable; urgency=medium

  * Release 6.0.42

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 04 Sep 2025 19:28:41 +0800

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,12 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
 export DEB_CXXFLAGS_MAINT_APPEND = -Ofast
+
+# 安全编译参数
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -Wall
+export DEB_CXXFLAGS_MAINT_APPEND = -Wall
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

## dtk6declarative 6.0.46

=== debian/changelog ===
dtk6declarative (6.0.46) unstable; urgency=medium

  * Release 6.0.46

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 06 Nov 2025 17:03:17 +0800

dtk6declarative (6.0.45) unstable; urgency=medium

  * Release 6.0.45

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 30 Oct 2025 21:48:49 +0800

dtk6declarative (6.0.44) unstable; urgency=medium

  * Release 6.0.44

 --  yeshanshan <yeshanshan@uniontech.com>  Thu, 16 Oct 2025 19:45:30 +0800

=== debian/rules ===
--- 
+++ 
@@ -21,3 +21,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DBUILD_EXAMPLES=OFF -DBUILD_DOCS=ON -DBUILD_VERSION=$(BUILD_VER) -DDTK_VERSION=$(PACK_VER)
+
+override_dh_makeshlibs:
+	dh_makeshlibs  -V "libdtk6declarative (>= $(shell echo $(VERSION) | cut -d '.' -f 1,2,3))"
+
